#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdio.h>
#define OFF 0x00
#define BIT0 0x01
#define BIT1 0x02
#define BIT2 0x04
#define BIT3 0x08
#define BIT4 0x10
#define BIT5 0x20
#define BIT6 0x40
#define BIT7 0x80
#define MAX_SEQ 50
#define A 1140671485

// retine secventa curenta
char seq[MAX_SEQ];




// Functia realizeaza o intarziere a semnalului de 'a' mili secunde
void delay_t(int nr_msec) {
	for(int i=0;i<nr_msec;i++)
		_delay_ms(500);
 }

 
// Functia de aprindere a unui LED
void LED_on(char led) {
	PORTA = led;
	delay_t(1);
	PORTA = OFF;
}


// Functia de final de joc. Indica faptul ca jocul a fost castigat, prin aprinderea tuturor LED-urilor
void game_won() {
	PORTA = 0xFF;
	delay_t(2);
	PORTA = OFF;
}

unsigned int a=1,b=1;
// Functia intoarce un numar aleator, intre 1 si 6. Este utilizata pentru aprinderea aleatoare a LED-urilor
int get_rand()
{
	a = (a + 231) % A;
	b = (a + b) % A;
	return (a + b) % 6;

}


 // Functia intoarce numarul butonului care a fost apasat
int buttonPressed() {
	int pressed = 0;
	int btn = -1;
	
	while(pressed == 0)	// asteapta cat timp nu s-a apasat un buton
	{
		if((PINC & BIT0) ==0) // BIT 0
		{
			PORTA = BIT0;
			while(((PINC & BIT0) ==0));
			PORTA = OFF;
			pressed = 1;
			btn = 0;
			break;
		}
			
		if((PINC & BIT1) ==0) // BIT 1
		{
			PORTA = BIT1;
			while(((PINC & BIT1) ==0));
			PORTA = OFF;
			pressed = 1;
			btn = 1;
			break;
		}
			
		if((PINC & BIT2) ==0) // BIT 2
		{
			PORTA = BIT2;
			while(((PINC & BIT2) ==0));
			PORTA = OFF;
			pressed = 1;
			btn = 2;
			break;
		}
			
		if((PINC & BIT3) ==0) // BIT 3
		{			
			PORTA = BIT3;
			while(((PINC & BIT3) ==0));
			PORTA = OFF;
			pressed = 1;
			btn = 3;
			break;
		}
			
		if((PINC & BIT4) ==0) // BIT 4
		{
			PORTA = BIT4;
			while(((PINC & BIT4) ==0));
			PORTA = OFF;
			pressed = 1;
			btn = 4;
			break;
		}
			
		if((PINC & BIT5) ==0) // BIT 5
		{
			PORTA = BIT5;
			while(((PINC & BIT5) ==0));
			PORTA = OFF;
			pressed = 1;
			btn = 5;
			break;
		}
	}
	
	return btn;	
	
}


// ==================================================================
int main()
{
	int random, i,correct,succes, button, crt;
	int cont=0;			// elementul curent din secventa
	char led;
	
	
	// setam pinii portului A ca pini de iesire
	DDRA = 0xFF;
	// setam pinii portului C ca pini de intrare
	DDRC = 0x00;
	// activam rezistenta de pull-up pe portul C
	PORTC = 0xFF;

	
	while(1){
				
		
		// activam rezistenta de pull-up pe portul C
		PORTC = 0xFF;										

		// setarea si memorarea secventei
		random = get_rand();
		seq[cont] = random;
		cont = cont + 1;
		
		// Verificam daca jocul s-a terminat si indicam prin aprinderea tuturor LED-urilor
		if (cont == MAX_SEQ)
		{
			for (int j=0; j<3;j++) 
			{
				game_won();
				delay_t(1);
			}
			break;
		}
		
		// se reda secventa curenta
		for(i=0;i<cont;i++)
		{
			switch(seq[i])
			{
				case 0: led = BIT0; break;
				case 1: led = BIT1; break;
				case 2: led = BIT2; break;
				case 3: led = BIT3; break;
				case 4: led = BIT4; break;
				case 5: led = BIT5; break;
			}
			LED_on(led);
			delay_t(1);
		}
		
		crt = 0;
		succes = 0;
		correct = 1;
		
		// cat timp nu s-a tastat toata secventa si secventa tastata e corecta
		while(succes == 0 && correct == 1)	
		{
			button = buttonPressed();
			delay_t(1);
			if(button != -1)	// s-a apasat corect un buton
			{
				// daca s-a apasat butonul gresit, se semnaleaza finalul de joc
				if(button != seq[crt])	
				{
					game_won();
					delay_t(1);
					correct = 0;
					cont = 0;
					break;
				}
			}
			crt++;
			if(crt >= cont)
				succes = 1;	// s-a introdus toata secventa			
		}

	}
	return 0;
}

